<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd"><html xmlns="http://www.w3.org/1999/xhtml"><head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.20"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<a class="dashingAutolink" name="autolink-93"></a><a class="dashAnchor" name="//apple_ref/cpp/Package/XHXKit%3A%20%2FUsers%2Fscar1900%2FDeveloper%2FXHXKit%2FXHXKit%2FClasses%2FBase%2FCategory%2FNSDate%2BXHXExtention.m%20%E6%BA%90%E6%96%87%E4%BB%B6"></a><title>XHXKit: /Users/scar1900/Developer/XHXKit/XHXKit/Classes/Base/Category/NSDate+XHXExtention.m 源文件</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">XHXKit
   &nbsp;<span id="projectnumber">4.10.0.12</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- 制作者 Doxygen 1.8.20 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'搜索');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','搜索');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow" onmouseover="return searchBox.OnSearchSelectShow()" onmouseout="return searchBox.OnSearchSelectHide()" onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_d522931ffa1371640980b621734a4381.html">Users</a></li><li class="navelem"><a class="el" href="dir_2f48480e0fdb0436fb8fd57a1ed5f613.html">scar1900</a></li><li class="navelem"><a class="el" href="dir_c8b33409012acfc781ba898892fd3b4c.html">Developer</a></li><li class="navelem"><a class="el" href="dir_0e1030ab80149b7e8d6dfd17946e9c40.html">XHXKit</a></li><li class="navelem"><a class="el" href="dir_c9ece41fcb3917ec137dcec44cd0055f.html">XHXKit</a></li><li class="navelem"><a class="el" href="dir_3a9521ad7c4429598be7e28fa39d3d14.html">Classes</a></li><li class="navelem"><a class="el" href="dir_e594291297641f362044084ee3bd79c2.html">Base</a></li><li class="navelem"><a class="el" href="dir_7b3ff33937589b3dcfba70141486f64a.html">Category</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">NSDate+XHXExtention.m</div>  </div>
</div><!--header-->
<div class="contents">
<a href="_n_s_date_09_x_h_x_extention_8m.html">浏览该文件的文档.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&nbsp;<span class="comment">//</span></div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&nbsp;<span class="comment">//  NSDate+XHXExtention.m</span></div>
<div class="line"><a name="l00003"></a><span class="lineno">    3</span>&nbsp;<span class="comment">//  Pods</span></div>
<div class="line"><a name="l00004"></a><span class="lineno">    4</span>&nbsp;<span class="comment">//</span></div>
<div class="line"><a name="l00005"></a><span class="lineno">    5</span>&nbsp;<span class="comment">//  Created by Leovir on 2019/4/2.</span></div>
<div class="line"><a name="l00006"></a><span class="lineno">    6</span>&nbsp;<span class="comment">//</span></div>
<div class="line"><a name="l00007"></a><span class="lineno">    7</span>&nbsp; </div>
<div class="line"><a name="l00008"></a><span class="lineno">    8</span>&nbsp;<span class="preprocessor">#import &#34;<a class="code" href="_n_s_date_09_x_h_x_extention_8h.html">NSDate+XHXExtention.h</a>&#34;</span></div>
<div class="line"><a name="l00009"></a><span class="lineno">    9</span>&nbsp;<span class="preprocessor">#import &lt;objc/runtime.h&gt;</span></div>
<div class="line"><a name="l00010"></a><span class="lineno"><a class="line" href="category_n_s_date_07_x_h_x_extention_08.html#adbe8aa9e792b1c16d6c3d2c92268f991">   10</a></span>&nbsp;<span class="keyword">static</span> <span class="keywordtype">char</span> kXHX_Calendar;</div>
<div class="line"><a name="l00011"></a><span class="lineno">   11</span>&nbsp;<span class="keyword">@implementation </span><a class="code" href="category_n_s_date_07_x_h_x_extention_08.html">NSDate (XHXExtention)</a></div>
<div class="line"><a name="l00012"></a><span class="lineno">   12</span>&nbsp;- (void)setCalendar:(NSCalendar *)calendar {</div>
<div class="line"><a name="l00013"></a><span class="lineno">   13</span>&nbsp;    objc_setAssociatedObject(<span class="keyword">self</span>, &amp;kXHX_Calendar, calendar, OBJC_ASSOCIATION_RETAIN_NONATOMIC);</div>
<div class="line"><a name="l00014"></a><span class="lineno">   14</span>&nbsp;}</div>
<div class="line"><a name="l00015"></a><span class="lineno">   15</span>&nbsp;- (NSCalendar *)calendar {</div>
<div class="line"><a name="l00016"></a><span class="lineno">   16</span>&nbsp;    <span class="keywordflow">return</span> objc_getAssociatedObject(<span class="keyword">self</span>, &amp;kXHX_Calendar);</div>
<div class="line"><a name="l00017"></a><span class="lineno">   17</span>&nbsp;}</div>
<div class="line"><a name="l00018"></a><span class="lineno">   18</span>&nbsp;- (BOOL)<a class="code" href="category_n_s_date_07_x_h_x_extention_08.html#aef7509ca59abe077275749c345bd0120">xhx_isSameYear</a> {</div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&nbsp;    <span class="keywordtype">int</span> unit = NSCalendarUnitYear | NSCalendarUnitMonth | NSCalendarUnitDay;</div>
<div class="line"><a name="l00020"></a><span class="lineno">   20</span>&nbsp;    <span class="comment">//  获取当前的年、月、日</span></div>
<div class="line"><a name="l00021"></a><span class="lineno">   21</span>&nbsp;    NSDateComponents *nowCmps = [<span class="keyword">self</span>.calendar components:unit fromDate:[NSDate date]];</div>
<div class="line"><a name="l00022"></a><span class="lineno">   22</span>&nbsp;    NSDateComponents *selfCmps = [<span class="keyword">self</span>.calendar components:unit fromDate:self];</div>
<div class="line"><a name="l00023"></a><span class="lineno">   23</span>&nbsp;    <span class="keywordflow">return</span> (nowCmps.year == selfCmps.year);</div>
<div class="line"><a name="l00024"></a><span class="lineno">   24</span>&nbsp;}</div>
<div class="line"><a name="l00025"></a><span class="lineno">   25</span>&nbsp;- (BOOL)<a class="code" href="category_n_s_date_07_x_h_x_extention_08.html#a1aab7fbe5dbc323f057b4dff739c51b9">xhx_isSameMonth</a> {</div>
<div class="line"><a name="l00026"></a><span class="lineno">   26</span>&nbsp;    <span class="keywordtype">int</span> unit = NSCalendarUnitYear | NSCalendarUnitMonth | NSCalendarUnitDay;</div>
<div class="line"><a name="l00027"></a><span class="lineno">   27</span>&nbsp;    <span class="comment">//  获取当前的年、月、日</span></div>
<div class="line"><a name="l00028"></a><span class="lineno">   28</span>&nbsp;    NSDateComponents *nowCmps = [<span class="keyword">self</span>.calendar components:unit fromDate:[NSDate date]];</div>
<div class="line"><a name="l00029"></a><span class="lineno">   29</span>&nbsp;    NSDateComponents *selfCmps = [<span class="keyword">self</span>.calendar components:unit fromDate:self];</div>
<div class="line"><a name="l00030"></a><span class="lineno">   30</span>&nbsp;    <span class="keywordflow">return</span> (nowCmps.year == selfCmps.year) &amp;&amp; (nowCmps.month == selfCmps.month);</div>
<div class="line"><a name="l00031"></a><span class="lineno">   31</span>&nbsp;}</div>
<div class="line"><a name="l00032"></a><span class="lineno">   32</span>&nbsp;- (BOOL)<a class="code" href="category_n_s_date_07_x_h_x_extention_08.html#a636413de9d4b5928731e4527b23e2f52">xhx_isSameWeek</a> {</div>
<div class="line"><a name="l00033"></a><span class="lineno">   33</span>&nbsp;    <span class="keywordtype">int</span> unit = NSCalendarUnitYear | NSCalendarUnitMonth | NSCalendarUnitWeekOfMonth;</div>
<div class="line"><a name="l00034"></a><span class="lineno">   34</span>&nbsp;    <span class="comment">//  获取当前的年、月、日</span></div>
<div class="line"><a name="l00035"></a><span class="lineno">   35</span>&nbsp;    NSDateComponents *nowCmps = [<span class="keyword">self</span>.calendar components:unit fromDate:[NSDate date]];</div>
<div class="line"><a name="l00036"></a><span class="lineno">   36</span>&nbsp;    NSDateComponents *selfCmps = [<span class="keyword">self</span>.calendar components:unit fromDate:self];</div>
<div class="line"><a name="l00037"></a><span class="lineno">   37</span>&nbsp;    <span class="keywordflow">return</span> (nowCmps.year == selfCmps.year) &amp;&amp; (nowCmps.month == selfCmps.month) &amp;&amp; (nowCmps.weekOfMonth == selfCmps.weekOfMonth);</div>
<div class="line"><a name="l00038"></a><span class="lineno">   38</span>&nbsp;}</div>
<div class="line"><a name="l00039"></a><span class="lineno">   39</span>&nbsp;- (BOOL)<a class="code" href="category_n_s_date_07_x_h_x_extention_08.html#a9bd36b82a32360d91e88a39284e6c4a9">xhx_isSameDay</a> {</div>
<div class="line"><a name="l00040"></a><span class="lineno">   40</span>&nbsp;    <span class="keywordtype">int</span> unit = NSCalendarUnitYear | NSCalendarUnitMonth | NSCalendarUnitDay;</div>
<div class="line"><a name="l00041"></a><span class="lineno">   41</span>&nbsp;    <span class="comment">//  获取当前的年、月、日</span></div>
<div class="line"><a name="l00042"></a><span class="lineno">   42</span>&nbsp;    NSDateComponents *nowCmps = [<span class="keyword">self</span>.calendar components:unit fromDate:[NSDate date]];</div>
<div class="line"><a name="l00043"></a><span class="lineno">   43</span>&nbsp;    NSDateComponents *selfCmps = [<span class="keyword">self</span>.calendar components:unit fromDate:self];</div>
<div class="line"><a name="l00044"></a><span class="lineno">   44</span>&nbsp;    <span class="keywordflow">return</span> (nowCmps.year == selfCmps.year) &amp;&amp; (nowCmps.month == selfCmps.month) &amp;&amp; (nowCmps.day == selfCmps.day);</div>
<div class="line"><a name="l00045"></a><span class="lineno">   45</span>&nbsp;}</div>
<div class="line"><a name="l00046"></a><span class="lineno">   46</span>&nbsp;- (NSString *)<a class="code" href="category_n_s_date_07_x_h_x_extention_08.html#adbe8aa9e792b1c16d6c3d2c92268f991">xhx_weekdayStringFromDate</a> {</div>
<div class="line"><a name="l00047"></a><span class="lineno">   47</span>&nbsp;    NSArray *weekdays = @[[NSNull null], @&#34;星期日&#34;, @&#34;星期一&#34;, @&#34;星期二&#34;, @&#34;星期三&#34;, @&#34;星期四&#34;, @&#34;星期五&#34;, @&#34;星期六&#34;];</div>
<div class="line"><a name="l00048"></a><span class="lineno">   48</span>&nbsp;    NSCalendar *calendar = [[NSCalendar alloc] initWithCalendarIdentifier:NSCalendarIdentifierGregorian];</div>
<div class="line"><a name="l00049"></a><span class="lineno">   49</span>&nbsp;    NSTimeZone *timeZone = [[NSTimeZone alloc] initWithName:@&#34;Asia/Shanghai&#34;];</div>
<div class="line"><a name="l00050"></a><span class="lineno">   50</span>&nbsp;    [calendar setTimeZone: timeZone];</div>
<div class="line"><a name="l00051"></a><span class="lineno">   51</span>&nbsp;    NSCalendarUnit calendarUnit = NSCalendarUnitWeekday;</div>
<div class="line"><a name="l00052"></a><span class="lineno">   52</span>&nbsp;    NSDateComponents *theComponents = [calendar components:calendarUnit fromDate:self];</div>
<div class="line"><a name="l00053"></a><span class="lineno">   53</span>&nbsp;    <span class="keywordflow">return</span> [weekdays objectAtIndex:theComponents.weekday];</div>
<div class="line"><a name="l00054"></a><span class="lineno">   54</span>&nbsp;}</div>
<div class="line"><a name="l00055"></a><span class="lineno">   55</span>&nbsp;<span class="keyword">@end</span></div>
</div><!-- fragment --></div><!-- contents -->
<div class="ttc" id="acategory_n_s_date_07_x_h_x_extention_08_html_aef7509ca59abe077275749c345bd0120"><div class="ttname"><a href="category_n_s_date_07_x_h_x_extention_08.html#aef7509ca59abe077275749c345bd0120">-[NSDate(XHXExtention) xhx_isSameYear]</a></div><div class="ttdeci">BOOL xhx_isSameYear()</div><div class="ttdef"><b>Definition:</b> <a href="_n_s_date_09_x_h_x_extention_8m_source.html#l00010">NSDate+XHXExtention.m:18</a></div></div>
<div class="ttc" id="a_n_s_date_09_x_h_x_extention_8h_html"><div class="ttname"><a href="_n_s_date_09_x_h_x_extention_8h.html">NSDate+XHXExtention.h</a></div></div>
<div class="ttc" id="acategory_n_s_date_07_x_h_x_extention_08_html"><div class="ttname"><a href="category_n_s_date_07_x_h_x_extention_08.html">NSDate(XHXExtention)</a></div><div class="ttdef"><b>Definition:</b> <a href="_n_s_date_09_x_h_x_extention_8h_source.html#l00012">NSDate+XHXExtention.h:12</a></div></div>
<div class="ttc" id="acategory_n_s_date_07_x_h_x_extention_08_html_a1aab7fbe5dbc323f057b4dff739c51b9"><div class="ttname"><a href="category_n_s_date_07_x_h_x_extention_08.html#a1aab7fbe5dbc323f057b4dff739c51b9">-[NSDate(XHXExtention) xhx_isSameMonth]</a></div><div class="ttdeci">BOOL xhx_isSameMonth()</div><div class="ttdef"><b>Definition:</b> <a href="_n_s_date_09_x_h_x_extention_8m_source.html#l00010">NSDate+XHXExtention.m:25</a></div></div>
<div class="ttc" id="acategory_n_s_date_07_x_h_x_extention_08_html_a9bd36b82a32360d91e88a39284e6c4a9"><div class="ttname"><a href="category_n_s_date_07_x_h_x_extention_08.html#a9bd36b82a32360d91e88a39284e6c4a9">-[NSDate(XHXExtention) xhx_isSameDay]</a></div><div class="ttdeci">BOOL xhx_isSameDay()</div><div class="ttdef"><b>Definition:</b> <a href="_n_s_date_09_x_h_x_extention_8m_source.html#l00010">NSDate+XHXExtention.m:39</a></div></div>
<div class="ttc" id="acategory_n_s_date_07_x_h_x_extention_08_html_adbe8aa9e792b1c16d6c3d2c92268f991"><div class="ttname"><a href="category_n_s_date_07_x_h_x_extention_08.html#adbe8aa9e792b1c16d6c3d2c92268f991">-[NSDate(XHXExtention) xhx_weekdayStringFromDate]</a></div><div class="ttdeci">NSString * xhx_weekdayStringFromDate()</div><div class="ttdef"><b>Definition:</b> <a href="_n_s_date_09_x_h_x_extention_8m_source.html#l00010">NSDate+XHXExtention.m:46</a></div></div>
<div class="ttc" id="acategory_n_s_date_07_x_h_x_extention_08_html_a636413de9d4b5928731e4527b23e2f52"><div class="ttname"><a href="category_n_s_date_07_x_h_x_extention_08.html#a636413de9d4b5928731e4527b23e2f52">-[NSDate(XHXExtention) xhx_isSameWeek]</a></div><div class="ttdeci">BOOL xhx_isSameWeek()</div><div class="ttdef"><b>Definition:</b> <a href="_n_s_date_09_x_h_x_extention_8m_source.html#l00010">NSDate+XHXExtention.m:32</a></div></div>
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
制作者&nbsp;<a href="http://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.8.20
</small></address>


</body></html>